import pygame,sys

#pygameの初期化
pygame.init()

#変数定義
i=0 #コスチューム切替とタイムラグ発生に使用
レフトフラグ = False #Trueの時に左に向く、Falseの時は右を向く
ダッシュ音フラグ=False #Trueの時に音が鳴る
ジャンプ音フラグ=False #Trueの時に音が鳴る
ボードフラグ=False #スケボーに接触した時にTrueになる

#スクリーンの作成
screen = pygame.display.set_mode((800, 650))

#画像アップロード
 #右向きのネコ
ネコ1_右 = pygame.image.load("image\コスチューム1.png")
ネコ2_右 = pygame.image.load("image\コスチューム2.png")
ネコ3_右 = pygame.image.load("image\コスチューム3.png")

 #左向きのネコ
ネコ1_左 = pygame.transform.flip(ネコ1_右, True, False)
ネコ2_左 = pygame.transform.flip(ネコ2_右, True, False)
ネコ3_左 = pygame.transform.flip(ネコ3_右, True, False)

 #背景画像
背景 = pygame.image.load("image\背景.png")

 #スケートボード
ボード = pygame.image.load("image\スケートボード.png")

 #右向きと左向きのネコ画像リスト
ネコリスト右=[ネコ1_右,ネコ2_右]
ネコリスト左=[ネコ1_左,ネコ2_左]

#効果音のアップロード
音_走る=pygame.mixer.Sound("sound\走る.mp3")
音_スケボー=pygame.mixer.Sound("sound\スケボー.mp3")
音_ジャンプ=pygame.mixer.Sound("sound\ジャンプ.wav")
BGM=pygame.mixer.Sound("sound\BGM.wav")

#ネコの初期位置
ネコ座標 = pygame.Rect(45, 410, 10, 100)#スケボーと衝突させるために修正
ボード座標 = pygame.Rect(325, 510, -10, -100)

#BGM
BGM.set_volume(0.1)#ボリュームを10%に調整
BGM.play(-1)  

#ネコとスケボーの処理
def メイン処理():
    global i,レフトフラグ,ダッシュ音フラグ,ジャンプ音フラグ,ボードフラグ
           
    #ネコの移動量を定義
    cx = 0
    cy = 0
    
    #ユーザからの入力を調べる
    key = pygame.key.get_pressed()
    
    #右向き矢印キーが押されたときの処理
    if key[pygame.K_RIGHT] :
        cx = 15
        i=i+1#タイムラグを作る
        レフトフラグ=False
        ダッシュ音フラグ=True
        
    #左向き矢印キーが押されたときの処理
    if key[pygame.K_LEFT]:
        cx = -15
        i=i+1
        レフトフラグ=True
        ダッシュ音フラグ=True
        
    #上向き矢印キーが押されたときの処理
    if key[pygame.K_UP]  :
        cy = -40
        i=i+1
        ジャンプ音フラグ=True
    elif ネコ座標.y<410:#重力を発生させている。elifを用いているので上向き矢印キーが押されていないときだけ重力が発生する
        ネコ座標.y = ネコ座標.y +40

    #ネコが端に行った時の処理
    if ネコ座標.x >810:#ネコが画面の右端まで来たら左端からあらわれる
        ネコ座標.x=-110
    elif ネコ座標.x < -110:#ネコが画面の左端まで来たら右端からあらわれる
        ネコ座標.x=800

    #スケボーが端に行った時の処理
    if ボード座標.x >810:#スケボーが画面の右端まで来たら左端からあらわれる
        ボード座標.x=-90
    elif ボード座標.x < -110:#スケボーが画面の左端まで来たら右端からあらわれる
        ボード座標.x=800

    # ネコの処理（ネコの座標を変更）
    ネコ座標.x = ネコ座標.x + cx
    ネコ座標.y = ネコ座標.y + cy

    #背景の転送
    screen.blit(背景,(0,0))
    if ボードフラグ==False:
        screen.blit(ボード,ボード座標)

    #レフトフラグがFalseのときは右向きのネコを転送、Trueのときは左向きのネコを転送
    if レフトフラグ==False and ボードフラグ==False:#レフトフラグがFalseのときは右向きのネコを転送
        screen.blit(ネコリスト右[i%2],ネコ座標)
    elif レフトフラグ==True and ボードフラグ==False:#レフトフラグがTrueのときは左向きのネコを転送
        screen.blit(ネコリスト左[i%2],ネコ座標)
    elif レフトフラグ==False and ボードフラグ==True:#ネコが右からスケボーに接触したときの転送処理
        screen.blit(ネコ3_右,ネコ座標)
    elif レフトフラグ==True and ボードフラグ==True:#ネコが左からスケボーに接触したときの転送処理
        screen.blit(ネコ3_左,ネコ座標)

    #効果音
    if ダッシュ音フラグ==True and i%5==1 and ボードフラグ==False:#iを使用してタイムラグを利用している。タイムラグがないと音が重なる。
        音_走る.play()
        ダッシュ音フラグ=False #音が連続してなるのを防ぐ
    elif ジャンプ音フラグ==True and i%3==1 :#iを使用してタイムラグを利用している。タイムラグがないと音が重なる。
        音_ジャンプ.play()
        ジャンプ音フラグ=False #音が連続してなるのを防ぐ
    elif ボードフラグ==True and i%4==1 :#iを使用してタイムラグを利用している。タイムラグがないと音が重なる。:
        音_スケボー.play()
    else:
        #一度、鳴った音は最後まで再生されるため、途中で止める
        音_走る.stop() 
        音_スケボー.stop()

    #スケボーとの衝突
    if ネコ座標.colliderect(ボード座標):
        ボード座標.x = ボード座標.x + cx #cx=15※ネコの移動量と同じ
        ボードフラグ=True #ネコとスケボーが衝突したことを表す
    else:
        ボードフラグ=False #ネコとスケボーが離れたことを表す

while True:
    メイン処理() #関数の呼び出し
    pygame.display.update() #ディスプレイの更新
    pygame.time.Clock().tick(60) #1秒間に60回実行する
    
    for event in pygame.event.get(): #閉じるボタンを押した時の処理
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
